/****************************************************************************/
/*                                                                          */
/*      mefkn.c                                                             */
/*                                                                          */
/*      Rutiner f|r meny-editor                                             */
/*                                                                          */
/*      1985-11-01 Stig Bystr|m                                             */
/*                                                                          */
/****************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <win/w_macros.h>
#undef FIOCLEX
#undef FIONCLEX
#include <signal.h>
#include <errno.h>
#include <sgtty.h>
#include "medef.h"


extern int pl;
extern char inbuf[256];
extern char speed[];
extern int sptr;
extern char str[];
extern int cnt;        /* # of characters left in keybuf[]*/
extern struct ring *root;
extern int antalfiler;
extern struct rectdes prekt[ANTEDFALT+ANTNYICON];
extern struct rectdes lrekt[ANTEDFALT+ANTNYICON];
extern struct lank nyikon[ANTNYICON];/*Strukturen f|r f{ltet med nya ikoner*/
extern struct arbfalt meny[3];  /*Strukturen f|r dom tre arbetsf{lten */
extern struct inne *topp;
extern struct inne *mitt;
extern struct inne *botten;
extern struct inne *dumm;

/****************************************************************************/

Rgraphics(filnamn,nr)
char filnamn[];
int  nr;
{
    char icbuf[BUFSIZE];
    char grbuf[BUFSIZE];
    char *icp,*grp;
    char ch;
    char chbuf[4096];
    int fd,fe,i,d;

    strcpy(icbuf,"./icons/");
    strcpy(grbuf,"./graphics/");

    icp = icbuf + strlen(icbuf);
    grp = grbuf + strlen(grbuf);

    strcpy(icp,filnamn);
    icp=icp+strlen(filnamn);

    *icp++='\0';

  /* L{s grafikfilnamn och |ppna filen. */

    fd = open(icbuf, 0);

    if(fd>0){
	ch='a'; /* a dummyv{rde */
	d=2;
	while((ch!=',')&&((d=read(fd,&ch,1))>0));/* L{s f|rbi /icons/filnamn*/
	ch='a'; /* a dummyv{rde */
	d=2;
	while ((ch!=',')&&((d=read(fd,&ch,1))>0)){ /* L{s grafikfilnamn */
	    *grp++=ch;
	}
	*--grp='\0';

        fe = open(grbuf, 0);
	if(fe>0){
            sendfill("\033[0m\033(H");
	    setorigin(nr);  /* S{tt origo */
	    send();
	    d=2;
	    /* L{s esc-sekvenserna till STDOUT) */
	    while((d=read(fe,chbuf,4096))>0){
		write(STDOUT,chbuf,d);
	    }
        }
    }
    close(fd);
    close(fe);
    sendfill("\033[0m\033(H");
    sendfill("\033:0;0;O"); /* S{tt tillbaka origo */
}
/****************************************************************************/

    /*****************************************************\
    *  Inl{sning av filnamn fr}n ./icons/ till filringen  *
    \*****************************************************/

initfilr()
{
    struct direct dirbuf;				     
    char name[BUFSIZE];
    struct ring *p,*nyp,*new();
    int fd;
    
    strcpy(name,"./icons/"); 
    fd=open(name,0);                  /* \ppna biblioteket ./icons/         */

    root=new();     /* Skapa f|rsta posten (Dummy)      */
    root->next = NULL;

    p = root;                         /* Starta uppbyggnaden av filringen */

    while (read(fd, (char *)&dirbuf, sizeof(dirbuf))>0){
	if (dirbuf.d_ino==0) continue;			     
	if (strcmp(dirbuf.d_name, ".") == 0		     
	   || strcmp(dirbuf.d_name, "..") == 0) continue;    

        nyp=new();    /* Skapa n{sta post                 */
        nyp->next = NULL;
        antalfiler++;                 /* Global filr{knare */
        strcpy(nyp->nod,dirbuf.d_name);  /* L{s filnamn*/
        p->next = nyp;
	p=nyp;
    }/* end while */
    p->next = root->next; /* Slutning av filringen */
    close(fd);
    return;
   /* Slut inl{sning till filringen                                         */
   /*************************************************************************/
}   
/****************************************************************************/
initinne()
{
    struct inne *ny();
    
    topp=ny();
    mitt=ny();
    botten=ny();
    topp->tomflg=TRUE;
    mitt->tomflg=TRUE;
    botten->tomflg=TRUE;
    topp->fore=NULL;
    topp->next=mitt;
    mitt->fore=topp;
    mitt->next=botten;
    botten->fore=mitt;
    botten->next=NULL;
    return;
}
/****************************************************************************/
scrupp()
{
    if(botten->next==NULL){
	dumm=ny();
	dumm->next=NULL;
	dumm->fore=botten;
	dumm->tomflg=TRUE;
	botten->next=dumm;
    }
    topp=mitt;
    mitt=botten;
    botten=botten->next;
}
/****************************************************************************/
scrner()
{
    if(topp->fore==NULL){
	dumm=ny();
	dumm->next=topp;
	dumm->fore=NULL;
	dumm->tomflg=TRUE;
	topp->fore=dumm;
    }
    botten=mitt;
    mitt=topp;
    topp=topp->fore;
}
/****************************************************************************/
clrinne(a)
int a;
{
    int i;

    switch (a) {
	case 0:
	    topp->tomflg=TRUE;
            for(i=0;i<NAMESIZE;i++) topp->nod[i]='0';
            break;

	case 1:
	    mitt->tomflg=TRUE;
            for(i=0;i<NAMESIZE;i++) mitt->nod[i]='0';
	    break;

        case 2:
	    botten->tomflg=TRUE;
            for(i=0;i<NAMESIZE;i++) botten->nod[i]='0';
	    break;
    }
}
/****************************************************************************/
intoinne(a,cmpbuf)
int a;
char cmpbuf[];
{
    int i;

    switch (a) {
	case 0:
	  for(i=0;i<NAMESIZE;i++) topp->nod[i]=cmpbuf[i];
	  topp->tomflg=FALSE;
          break;

	case 1:
	  for(i=0;i<NAMESIZE;i++) mitt->nod[i]=cmpbuf[i];
	  mitt->tomflg=FALSE;
	  break;

        case 2:
	  for(i=0;i<NAMESIZE;i++) botten->nod[i]=cmpbuf[i];
	  botten->tomflg=FALSE;
	  break;
    }
    
}
/****************************************************************************/
lagrameny(a)  /* INDATA: a = int 0,1 eller 2  */
int a; 
{
   char icname[BUFSIZE];
   char installname[BUFSIZE];
   char *icbp,*icep,*inbp,*inep,*icn,*inn;
   int  i,j,k,dummy,fd,d;
   int plats;
   char plch;
   char ch;

   icn=icname;
   inn=installname;
   
   strcpy(icname,"./icons/");
   strcpy(installname,"./installed/");

   icbp = icname + strlen(icname);
   inbp = installname + strlen(installname);

   k = 0;
   while((meny[a].nummer[k]!='*')&&(k<NAMESIZE)) k++;
   if(k!=NAMESIZE){
       for(j=(k+1);j<NAMESIZE;j++) meny[a].nummer[j] = '0';
       meny[a].nummer[NAMESIZE] = '\0';

       for(i=0;i<ANTFALT;i++){      /* G} igenom alla f{lt  */
         dummy=strcmp(meny[a].falt[i].iconf,"00000000000000");
	 if(dummy==0){
	     meny[a].falt[i].flyttflg == FALSE;
	 }

            /* Har flyttning skett ? */
         if(meny[a].falt[i].flyttflg == TRUE){
	   for(j=0,icep=icbp;j<NAMESIZE;j++){
	       *icep++ = meny[a].falt[i].iconf[j];
	   }
	   *icep++ = '\0';

           fd=open(icname,0);/* Kontrollera att det finns en /icons/-fil */

	   if(fd>0){
               /* Ta reda p} r{tt tecken enligt namngivningsreglerna */
	       plats=i;
	       if((plats>=0)&&(plats<=8)) plch=(plats+'1');
  	                             else plch=(plats-9+'a');

   	       meny[a].nummer[k] = plch;  /* s{tt r{tt f{ltnummer */

               for(j=0,inep=inbp;j<NAMESIZE;j++) /* Plocka ut installnummer */
	           *inep++ = meny[a].nummer[j];
               *inep++ = '\0';
               dummy = link(icn, inn); /* Skapa en ny l{nk  */
	   } /* end if(fd>0....  */
	   close(fd);
	   meny[a].falt[i].flyttflg=FALSE;
         } /* end if (meny....  */
       } /* end for  */
       meny[a].nummer[k] = '*';  /* s{tt tillbaka '*'  */
       for(j=(k+1);j<NAMESIZE;j++) meny[a].nummer[j] = ' ';
       meny[a].nummer[NAMESIZE] = '\0';
   
       if(k>1){
           cleanmeny(a);
       }
       return(k);
   }
   return(0);
}
/*********slut lagrameny(a)**************************************************/

lasnyikon()   /********************************************\
              * 			                   *
              * L{ser in filnamn fr}n filring till nyikon  *
              * 			                   *
              \********************************************/
{	      
    struct stat stbuf;
    struct ring *p;
    char name[BUFSIZE];
    char nodbuf[NAMESIZE];    
    char *nbp,*nep;
    int plats=0;
    int j =0;
    int fd,i,x,y;					     
							     
    /* Rensa nyikon */
    cleannyikon();
    
    strcpy(name,"./icons/");
    nbp = name + strlen(name);
    p = root->next;
    while ((j<antalfiler)&&(plats<(ANTNYICON-5))){

	for (i=0,nep=nbp;i < NAMESIZE; i++){ /* L{s filnamn*/
	   *nep++ = p->nod[i];
	}
	*nep++ = '\0';
        for (i=0;i < NAMESIZE; i++){ /* L{s filnamn*/
	   nyikon[plats].iconf[i] = p->nod[i];
	}
        Rgraphics(nyikon[plats].iconf,plats+ANTEDFALT);
	plats++;
        j++;
	p=p->next;  /* Till n{sta post */
    }/* end while */
    root->next = p; /* L{nka om root till post efter sist l{sta post */
    send();
    return;
}
/*******slut lasnyikon*******************************************************/

ulink(nr,fl)
int nr,fl;
              /********************************************\
              * 			                   *
              * Plockar bort l{nkar till utplockade filer  *
              * 			                   *
              \********************************************/
{	      
    char installname[BUFSIZE];
    char *inbp,*inep;
    int  k,i,j,fd,dummy;
    char plch;

    strcpy(installname,"./installed/");
    inbp = installname + strlen(installname);

    k=0;
    while((meny[nr].nummer[k])!='*')k++;

    if((fl>=0)&&(fl<=8)) plch=(fl+'1');
      else plch=(fl-9+'a');

    meny[nr].nummer[k] = plch;  /* s{tt r{tt f{ltnummer */

    for(j=(k+1);j<NAMESIZE;j++) meny[nr].nummer[j] = '0';

    for(i=0,inep=inbp;i<NAMESIZE;i++){
	*inep++=meny[nr].nummer[i];
    }
    *inep++ = '\0';
    meny[nr].nummer[k] = '*';  /* s{tt tillbaka '*' */

    for(j=(k+1);j<NAMESIZE;j++) meny[nr].nummer[j] = ' ';
    meny[nr].nummer[NAMESIZE] = '\0';

    fd=open(installname,0);
    if(fd < 0){ /* ERROR filen {r EJ installerad */
    } /* end if */
    else{             /* Filen har flyttats fr}n tidigare position  */
        dummy = unlink(installname);  /* Ta bort l{nken */
    } /* end else */

    close(fd);     /* st{ng installname */

    return;
}
/******slut ulink(nr,fl)*************************************************/

findfalt(di,c)
int di;
char c;
{
    int ut;

    ut=((c-'a')+((di-1)*12));
    return(ut);
}
/******slut findfalt*********************************************************/

rectmove(from,to,op)
int from,to,op;
{
    int xbor,ybor,xeor,yeor;

    if(from<ANTEDFALT+ANTNYICON){
	/* leta i prekt/lrekt efter origo-koordinater */
	if(pl==0){ /* portr{ttmod */
	    xbor=prekt[from].r_xorig;
	    ybor=prekt[from].r_yorig;
	}
	else{
	    xbor=lrekt[from].r_xorig;
	    ybor=lrekt[from].r_yorig;
	}
    }
    if(from==RUTDUMMY){
	if(pl==0){
	    xbor=GLUGGPX;
	    ybor=GLUGGPY;
	}
	else{
	    xbor=GLUGGLX;
	    ybor=GLUGGLY;
	}
    }
    if(from==GRARUT){
	/* G|r fill med gr}tt i f{ltet som anges av to */
        fillgrayfalt(to);
	goto exit3;
    }
    if(from==SVARTRUT){
	/* G|r fill med svart i f{ltet som anges av to */
	fillfalt(to);
	goto exit3;
    }

    if(to<ANTEDFALT+ANTNYICON){
	/* leta i prekt/lrekt efter origo-koordinater */
	if(pl==0){ /* portr{ttmod */
	    xeor=prekt[to].r_xorig;
	    yeor=prekt[to].r_yorig;
	}
	else{
	    xeor=lrekt[to].r_xorig;
	    yeor=lrekt[to].r_yorig;
	}
    }
    if(to==RUTDUMMY){
	if(pl==0){
	    xeor=GLUGGPX;
	    yeor=GLUGGPY;
	}
	else{
	    xeor=GLUGGLX;
	    yeor=GLUGGLY;
	}
    }

    sendfill("\033:");
    numout(xbor);
    sendfill(";");
    numout(ybor);
    sendfill(";");
    numout(xeor);
    sendfill(";");
    numout(yeor);
    sendfill(";");
    numout(WIDTH);
    sendfill(";");
    numout(HEIGHT);
    sendfill(";");
    numout(op);
    sendfill("r");
exit3:;
    send();

    return;
}

/*****slut rectmove**********************************************************/

lasmeny(a,cmpbuf)  /* Innan anrop m}ste en s|kstr{ng l{ggas in i cmpbuf     */
int a;             /* Den ska inneh}lla I,menynumren och * f|r aktuell meny */
char cmpbuf[];
{
   char icgrl[NAMESIZE+1];
   char name[BUFSIZE];
   char plats;
   char *nbp,*nep;
   int i,j,k,r,fd,d;
   char ch;
   
   icgrl[NAMESIZE]='\0';  /* Str{ngslut */

   for(j=0;j<NAMESIZE;j++)meny[a].nummer[j]=' ';

   strcpy(name,"./installed/");
   nbp=name+strlen(name);

   r=0;
   while(cmpbuf[r]!='*'){
       *nbp++=cmpbuf[r];
       meny[a].nummer[r]=cmpbuf[r];
       r++;
   }
   meny[a].nummer[r]=cmpbuf[r];
   meny[a].nummer[r+1]='\0';

   nep=nbp;
   nep++;

   r++;
   while(r<NAMESIZE){
       *nep++='0';
       r++;
   }
   *nep++='\0';
   
   for(i=0; i<ANTFALT; i++){

       meny[a].falt[i].flyttflg=FALSE;

       nep=nbp;
       /* Ta reda p} r{tt tecken enligt namngivningsreglerna */
       plats=i;
       if((plats>=0)&&(plats<=8)) *nep++=(plats+'1');
                             else *nep++=(plats-9+'a');

       fd=open(name,0);

       if(fd>0){
	   for(j=0;j<NAMESIZE;j++)icgrl[j]=' ';

	   j=0;
	   ch='a'; /* a dummy */
           d=1;

	   while( (ch!=',') && ((d>0) && (j<NAMESIZE)) ){
	       d=read(fd,&ch,1);
	       if(ch!=',') icgrl[j]=ch;
	       j++;
	   }

           if(ch==','){
	       j--;
	       icgrl[j]='\0';
	   }
	   else icgrl[j]='\0';

	   close(fd);

           strcpy(meny[a].falt[i].iconf,icgrl);

           if(i<12){ /* Ska grafik ritas ? (Se upp med numreringen)*/
               Rgraphics(icgrl,((a*12)+i));
	   }
       }

       close(fd);       
   }
   send();
   return;
}
/****************************************************************************/

cleanmeny(a) /* INDATA: a = int 0,1 eller 2  */
int a;
{
    int i,j;

    for(i=0;i<ANTFALT;i++){
	for(j=0;j<NAMESIZE;j++){
	    meny[a].falt[i].iconf[j] = '0';
	}
        meny[a].falt[i].flyttflg = FALSE;
    }

    for(i=0;i<NAMESIZE;i++)
        meny[a].nummer[i]=' ';

    for(i=a*12;i<(a*12)+12;i++){
        rectmove(SVARTRUT,i,0);
    }

    return;
}
/****************************************************************************/
cleannyikon()
{
    int i,j;

    for(i=0;i<ANTNYICON;i++){
        for(j=0;j<NAMESIZE;j++){
	    nyikon[i].iconf[j]='0';
	}
	nyikon[i].flyttflg = FALSE;
        rectmove(SVARTRUT,ANTEDFALT+i,0); /* Ta bort grafiken p} sk{rmen */
    }
    return;
}
/****************************************************************************/
bytmeny(a,b)
int a,b;
{
    int i,j;

    strcpy(meny[b].nummer,meny[a].nummer);
    for (i=0;i<ANTFALT;i++){
	meny[b].falt[i].flyttflg=meny[a].falt[i].flyttflg;
        strcpy(meny[b].falt[i].iconf,meny[a].falt[i].iconf);
    }
}
/****************************************************************************/

menyiarbf()
{
    if(pl==0){
	gcur(MPX1,MPY1);
	fill(MPX1+(14*9)-1,MPY1+13,0);
	sendfill(meny[0].nummer);
	gcur(MPX2,MPY2);
	fill(MPX2+(14*9)-1,MPY2+13,0);
	sendfill(meny[1].nummer);
	gcur(MPX3,MPY3);
	fill(MPX3+(14*9)-1,MPY3+13,0);
	sendfill(meny[2].nummer);
    }
    else{
	gcur(MLX1,MLY1);
	fill(MLX1+(14*9)-1,MLY1+13,0);
	sendfill(meny[0].nummer);
	gcur(MLX2,MLY2);
	fill(MLX2+(14*9)-1,MLY2+13,0);
	sendfill(meny[1].nummer);
	gcur(MLX3,MLY3);
	fill(MLX3+(14*9)-1,MLY3+13,0);
	sendfill(meny[2].nummer);
    }
    send();
}

/*                                                                          */
/*****slut mefkn.c***********************************************************/
