/****************************************************************************/
/*      memain.c                                                            */
/*                                                                          */
/*      Rutiner f|r menu-editor                                             */
/*                                                                          */
/*      1985-10-07 Stig Bystr|m                                             */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <win/w_macros.h>
#undef FIOCLEX
#undef FIONCLEX
#include <signal.h>
#include <sgtty.h>
#include "medef.h"             /* Include definitioner                      */

/****************************************************************************/
/*                         D A T A      A R E A                             */

struct lank nyikon[ANTNYICON];/* Strukturen f|r f{ltet med nya ikoner       */
struct arbfalt meny[3];       /* Strukturen f|r dom tre arbetsf{lten        */
struct ring *new()            /* ring definieras i icdef.h                  */
{
    return((struct ring *) malloc(sizeof(struct ring)));
}
struct inne *ny()             /* inne definieras i icdef.h                  */
{
    return((struct inne *) malloc(sizeof(struct inne)));
}

struct ring *root;            /* Rot till filringen                         */
struct inne *topp;            /* Topp till dubbell{nkade kedjan             */
struct inne *mitt;            /* Mitt till dubbell{nkade kedjan             */
struct inne *botten;          /* Botten till dubbell{nkade kedjan           */
struct inne *dumm;            /* Dummy till dubbell{nkade kedjan            */

char cmpbuf[NAMESIZE];        /* Filnamnsbuffert                            */
char *dst,*src ;              /* string pointers                            */
char extbuf[NAMESIZE+1];      /* Anv{nds till att kontrollera ext-typ       */
char inbuf[256];              /* Input buffer                               */
char koll[NAMESIZE];          /* Dummy f|r testning av faderskap hos NOD    */
char plch;                    /*                                            */
char speed[4096];             /* Speeding up buffer of screen output        */
char string[256];             /* Temp string buffer                         */
char temp[NAMESIZE+1];        /* Dummy f|r flyttning av fildata             */

int antalfiler = 0;           /* Filr{knare f|r filringen                   */
int childto;                  /* Under vilket f{lt ska den nya menyn ligga  */
int clarbf[3];                /* H}ller reda p} vilka arbetsfalt som {r rena*/
int cnt=0;                    /* chars left in keybuf                       */
int frombuf,tobuf;            /* F|r flyttning av filnamn                   */
int g;                        /* Anv{nds till att ta reda p} menynamnl{ngd  */
int intflag;                  /* flag for moved window (redraw)             */
int i,j;                      /* Loopr{knare som kan anv{ndas fritt         */
int klick;                    /* H}ller reda p} om 1:a eller 2:a valet      */
int movefrom,moveto;          /* fr}n/till vilket arbetsf{lt                */
int over;                     /* \verflagga s{tts d} |vermeny |nskas        */
int pl;                       /* global portrait/landscape flag             */
int plats,topls;              /*                                            */
int scr[3];                   /* Hur mycket har arbetsf{lt scrollats        */
int sptr;                     /* pointer into speed[]                       */
int tmp;                      /*                                            */
int toppchk;                  /*                                            */
int under;                    /* Underflagga s{tts d} undermeny |nskas      */
int x,y;                      /* pixel-cursor address                       */
/*                                                                          */
/****************************************************************************/


main(argc,argv)         /* If argc >1, assume VT100 text terminal,      */
int argc;               /* otherwise ABC1600-screen is assumed          */
char *argv[];           /* If used with window-handler,mouse is used    */

{
    register char *string;
    char c,d,plch;
    int di,g;
    
    setraw();
    cls();

    /* Initialize the automatic redrawing of the window.         */
    if (w_reini() != 0 ){
	sendfill("Window error.\n");
    }

    tmp = winini();         /* initialize window menu       */
    if( tmp != 0 ){

	Rmicons(0);
	exit();
    }

    initfilr();             /* Initiera filringen     */
    initinne();             /* Initiera inne-kedjan   */

    sendfill("\033[1v");    /* cursor off                   */

    for(i=0;i<3;i++){       /* nollst{ll scroll data och clarbf */
        scr[i]=0;    
	clarbf[i]=TRUE;
	cleanmeny(i);
    }
    cleannyikon();
    cmpbuf[0]='I';
    cmpbuf[1]='*';
    lasmeny(0,cmpbuf);      /* Initiering av huvudmenyn   */
    intoinne(0,cmpbuf);

    clarbf[0] = FALSE;
    menyiarbf();
    klick = 1;
    under = FALSE;
    over = FALSE;
    send();

/****** MAIN COMMAND LOOP ***************************************************/

        for ( ; ; ) {               /* start loop                   */
	    sendfill("\033:8M");    /*8 set mouse mode: report on button*/
            d = getone();           /* get a character      */
            c = getone();           /* get a character      */
            intflag = 0;            /* reset int flag.(used by strin) */
            send();                 /* send to terminal     */
            switch ( d ) {

	    case '5':
   	       if(klick==1){               
                  switch ( c ) {

                  case 'A':
                     /*UNDER*/
                     if((under==FALSE)&&(over==FALSE)){
		         under = TRUE;
			 if(pl==0){
			     gcur(202,845);
			     fill(212,855,1); /* svart ruta i under */
			 }
			 else{
			     gcur(105,177);
			     fill(115,187,1); /* svart ruta i under */
			 }
		     }
                     else{
			 under = FALSE;
			 if(pl==0){
			     gcur(202,845);
			     fill(212,855,0); /* vit ruta i under */
			 }
			 else{
			     gcur(105,177);
			     fill(115,187,0); /* vit ruta i under */
			 }
		     }
		     send();
		  break;

                  case 'B':
                     /*OVER*/
                     if((over==FALSE)&&(under==FALSE)){
		         over = TRUE;
			 if(pl==0){
			     gcur(289,845);
			     fill(299,855,1); /* svart ruta i over */
			 }
			 else{
			     gcur(192,177);
			     fill(202,187,1); /* svart ruta i over */
			 }
		     }
                     else{
			 over = FALSE;
			 if(pl==0){
			     gcur(289,845);
			     fill(299,855,0); /* vit ruta i over */
			 }
			 else{
			     gcur(192,177);
			     fill(202,187,0); /* vit ruta i over */
			 }
		     }
		     send();
                  break;

                  case 'C':
                     /*MORE*/
		     lasnyikon();
                  break;

                  case 'D':
                     /*SCROLLUPP*/

		     if(clarbf[0]==FALSE) toppchk=lagrameny(0);
                     if(toppchk==1) cleanmeny(0);

                     for(i=12;i<36;i++) rectmove(i,i-12,0);

		     bytmeny(1,0);
		     scr[0] = scr[1];
		     clarbf[0]=clarbf[1];
		     bytmeny(2,1);
		     scr[1] = scr[2];
		     clarbf[1]=clarbf[2];
		     cleanmeny(2);
		     scr[2] = 0;
		     clarbf[2]=TRUE;

		     scrupp(); /**/
		     if(botten->tomflg==FALSE){
		         clarbf[2]=FALSE;
			 for(i=0;i<NAMESIZE;i++) cmpbuf[i]=botten->nod[i];
			 lasmeny(2,cmpbuf); /*f|rra nerom);*/
		     }
                     menyiarbf();
		  break;

                  case 'E':
                     /*SCRUPP1*/
                     if(pl==0){
		         pscupp(0);
		     }
		     else{
		         lscupp(0);
		     }
		  break;

                  case 'F':
                     /*SCRUPP2*/
                     if(pl==0){
		         pscupp(1);
		     }
		     else{
		         lscupp(1);
		     }
		  break;

                  case 'G':
                     /*SCRUPP3*/
                     if(pl==0){
		         pscupp(2);
		     }
		     else{
		         lscupp(2);
		     }
		  break;

                  case 'H':
                     /*SCROLLNER*/
 	 	     if(clarbf[2]==FALSE) toppchk=lagrameny(2);
                     if(toppchk==1) cleanmeny(2);

                     for(i=23;i>=0;i--){
			 rectmove(i,i+12,0);
		     }

                     bytmeny(1,2);
	             scr[2] = scr[1];
		     clarbf[2]=clarbf[1];
		     bytmeny(0,1);
		     scr[1] = scr[0];
		     clarbf[1]=clarbf[0];
		     cleanmeny(0);
		     scr[0] = 0;
		     clarbf[0]=TRUE;

		     scrner(); /**/

		     if(topp->tomflg==FALSE){
		         clarbf[0]=FALSE;
			 for(i=0;i<NAMESIZE;i++){
			     cmpbuf[i]=topp->nod[i];
			 }
			 lasmeny(0,cmpbuf);  /*f|rra |verom*/
		     }

		     if(pl==0){
			 gcur(MPX1,MPY1);
			 fill(MPX1+(14*9)-1,MPY1+13,0);
			 sendfill(meny[0].nummer);
			 gcur(MPX2,MPY2);
			 fill(MPX2+(14*9)-1,MPY2+13,0);
			 sendfill(meny[1].nummer);
			 gcur(MPX3,MPY3);
			 fill(MPX3+(14*9)-1,MPY3+13,0);
			 sendfill(meny[2].nummer);
	             }
		     else{
			 gcur(MLX1,MLY1);
			 fill(MLX1+(14*9)-1,MLY1+13,0);
			 sendfill(meny[0].nummer);
			 gcur(MLX2,MLY2);
			 fill(MLX2+(14*9)-1,MLY2+13,0);
			 sendfill(meny[1].nummer);
			 gcur(MLX3,MLY3);
			 fill(MLX3+(14*9)-1,MLY3+13,0);
			 sendfill(meny[2].nummer);
		     }
		  break;     

                  case 'I':
                     /*SCRNER1*/
                     if(pl==0) pscner(0);
		          else lscner(0);
  	          break;

                  case 'J':
		     /*SCRNER2*/
                     if(pl==0) pscner(1);
		          else lscner(1);
	          break;

                  case 'K':
                     /*SCRNER3*/
                     if(pl==0) pscner(2);
		          else lscner(2);
		  break;

                  case 'L':
                     /*SAVE*/
		     for(i=0;i<3;i++) save(i);
		  break;

                  case 'M':
		     /*SAVE1*/
		     save(0);
                  break;

                  case 'N':
		     /*SAVE2*/
		     save(1);
		  break;                        

                  case 'O':
                     /*SAVE3*/
                     save(2);
		  break;

                  case 'Q':
                     /*QUIT*/
		     goto exit1; /*Avsluta programet*/
                  break;

		  case '\033':
		     cnt=0;    /*clear keybuf    */
		  break;
                };       /* end of switch        */
	       } /* end if(klick....*/
    	    break;
	    /*end of case 5*/
		    
	    case '1':
	    case '2':
	    case '3':
	    case '4':
	      di=d-'0';
	      if((under == FALSE)&&(over == FALSE)){
	        if(klick == 1){
		    temp[NAMESIZE]='\000';
		    movefrom=findfalt(di,c);
		    frombuf=di-1;
		    plats=c-'a';
		    if (di!=4){ /*di=1,2,3 -> fr}n meny di==4 -> fr}n nyikon*/
		      if(clarbf[di-1]==FALSE){/* Arbetsf{lt som anv{nds ? */
			plats=plats+scr[frombuf];
			g=0;
			for(i=0;i<NAMESIZE;i++){
			    temp[i]=meny[frombuf].falt[plats].iconf[i];
			    extbuf[i]=meny[frombuf].nummer[i];
			    if(meny[frombuf].nummer[i]=='*')g=i;
			}
			if((plats>=0)&&(plats<=8)) plch=(plats+'1');
  	                                      else plch=(plats-9+'a');
	                extbuf[g]=plch;
			g++;
			i=extcheck(temp);
			if(i==1){/* NOD */
			    i=undercheck(g,extbuf,frombuf);
			    if(i==1){/* Meny finns under -> avbryt */
				/* Felmeddelande ? */
			        goto exit2;
			    }
			}
		      }/* end if(clarbf[di-1]==FALSE){ */
		      else goto exit2;
		    }/* end if (di!=4){ */

		    /* flytta   1   till dummy invert
		              gr}tt till 1          */
                    rectmove(movefrom,RUTDUMMY,1);
                    rectmove(GRARUT,movefrom,0);

		    klick=2;
                }
		else{ /* klick == 2 */
		    moveto=findfalt(di,c);

		    tobuf=di-1;
  	 	    topls=(c-'a'+scr[tobuf]);

		    if (frombuf != 3){/* fr}n meny*/
                        ulink(frombuf,plats);
			if (tobuf != 3){/*till meny*/
			  if (clarbf[di-1]==FALSE){/*Arbetsf{lt som anv{nds?*/
                            i=0;
			    for(i=0;i<NAMESIZE;i++){
			        koll[i]=meny[tobuf].falt[topls].iconf[i];
			        extbuf[i]=meny[tobuf].nummer[i];
				if(meny[tobuf].nummer[i]=='*')g=i;
			    }
			    if((topls>=0)&&(topls<=8)) plch=(plats+'1');
  	                                          else plch=(plats-9+'a');
	                    extbuf[g]=plch;
			    g++;
			    i=extcheck(koll);
			    if(i==1){/* NOD */
			        i=undercheck(g,extbuf,frombuf);
				if(i==1){/* Meny finns under -> avbryt */
				    /* Felmeddelande ? */
				    goto exit2;
				}
			    }
/*########*/
			    ulink(tobuf,topls);

			    for(i=0;i<NAMESIZE;i++){
                                meny[frombuf].falt[plats].iconf[i]=
				     meny[tobuf].falt[topls].iconf[i];
   	 	                meny[tobuf].falt[topls].iconf[i]=temp[i];
			    }

			    meny[frombuf].falt[plats].flyttflg=TRUE;
			    meny[tobuf].falt[topls].flyttflg=TRUE;
			  }/* end if (clarbf[.....*/
			  else goto exit2;
			}
			else{/*till nyikon*/
 			    for(i=0;i<NAMESIZE;i++){
	          meny[frombuf].falt[plats].iconf[i]=nyikon[c-'a'].iconf[i];
			        nyikon[c-'a'].iconf[i]=temp[i];
			    }
 	 	            meny[frombuf].falt[plats].flyttflg=TRUE;
			}

		    }
		    else{/*fr}n nyikon */
			for(i=0;i<NAMESIZE;i++)
			    temp[i]=nyikon[plats].iconf[i];
			if (tobuf != 3){/*till meny*/
			  if (clarbf[di-1]==FALSE){/*Arbetsf{lt som anv{nds?*/
 		            i=0;
			    for(i=0;i<NAMESIZE;i++){
			        koll[i]=meny[tobuf].falt[topls].iconf[i];
			        extbuf[i]=meny[tobuf].nummer[i];
				if(meny[tobuf].nummer[i]=='*')g=i;
			    }
			    if((topls>=0)&&(topls<=8)) plch=(plats+'1');
  	                                          else plch=(plats-9+'a');
	                    extbuf[g]=plch;
			    g++;
			    i=extcheck(koll);
			    if(i==1){/* NOD */
			        i=undercheck(g,extbuf,tobuf);
				if(i==1){/* Meny finns under -> avbryt */
				    /* Felmeddelande ? */
				    goto exit2;
				}
			    }
			    for(i=0;i<NAMESIZE;i++){
				nyikon[plats].iconf[i]=
                                      meny[tobuf].falt[topls].iconf[i];
		                meny[tobuf].falt[topls].iconf[i]=temp[i];
			    }
    /* Plocka bort l{nken som h{nger fr}n nyikon (utplockad fil) */
                            ulink(tobuf,topls);
			    meny[tobuf].falt[topls].flyttflg=TRUE;
                          }/* end if(clarbf[.....*/
			  else goto exit2;
			}
			else{/*till nyikon*/
			    for(i=0;i<NAMESIZE;i++){
		                nyikon[plats].iconf[i]=nyikon[c-'a'].iconf[i];
			        nyikon[c-'a'].iconf[i]=temp[i];
			    }
			}/*end else till nyikon */
		    }/*end else fr}n nyikon*/    

		    /*flytta   2   till 1
		             dummy till 2 invert
			     svart till dummy   */
	            rectmove(moveto,movefrom,0);
	            rectmove(RUTDUMMY,moveto,1);
	            rectmove(SVARTRUT,RUTDUMMY,0);

		    klick=1;
		}/*end else klick == 2.... */
              }/*end if((under.....*/
	      else{  /* under eller over == TRUE  */
		  klick=1;
		  if(di>3){
		      goto exit2;       /* Ingen undermeny vald */
		  }
		  if(meny[di-1].nummer[0]!='I'){
		      goto exit2;       /* Ingen undermeny vald */
		  }

		  if(under == TRUE){/* under == TRUE */


		      for(i=0;i<NAMESIZE;i++){
		          temp[i]=meny[di-1].falt[(c-'a')+scr[di-1]].iconf[i];
		      }
		      i=extcheck(temp);
		      if(i==0) goto exit2;

		      under = FALSE;
		      if(pl==0){
			  gcur(202,845);
			  fill(212,855,0); /* svart ruta i under */
		      }
		      else{
			  gcur(105,177);
			  fill(115,187,0); /* svart ruta i under */
		      }

		      /* L{s vart den ska vara */		      
		      i=0;
		      while(meny[di-1].nummer[i] != '*'){
		          cmpbuf[i]=meny[di-1].nummer[i];
		          g=i;
			  i++;
		      }

		      if((g+2)>=NAMESIZE) goto exit2;

		      if(((c-'a')+scr[di-1])<9) plch=((c-'a')+scr[di-1]+'1');
		                          else plch=((c-'a')+scr[di-1]-9+'a');
                      cmpbuf[g+1]=plch;
		      cmpbuf[g+2]='*';
		  }
		  else{ /* over == TRUE */


		      /* L{s vart den ska vara */		      
		      i=0;
		      while(meny[di-1].nummer[i] != '*'){
		          cmpbuf[i]=meny[di-1].nummer[i];
		          g=i;
			  i++;
		      }

		      if(g<1) goto exit2; /* Arbetsf{lt = I*  */

		      over = FALSE;
		      if(pl==0){
			  gcur(289,845);
			  fill(299,855,0); /* svart ruta i over */
		      }
		      else{
			  gcur(192,177);
			  fill(202,187,0); /* svart ruta i over */
		      }

		      cmpbuf[g]='*';
		  }
		  if(clarbf[0]==TRUE){
		      /* Anv{nd meny[0] */
		      clarbf[0]=FALSE;
		      lasmeny(0,cmpbuf);
		      intoinne(0,cmpbuf);
		      if(pl==0) gcur(MPX1,MPY1);
		           else gcur(MLX1,MLY1);
		      sendfill(meny[0].nummer);
		      goto exit2;
		  }
		  if(clarbf[1]==TRUE){
			      /* Anv{nd meny[1] */
			      clarbf[1]=FALSE;
			      lasmeny(1,cmpbuf);
			      intoinne(1,cmpbuf);
			      if(pl==0) gcur(MPX2,MPY2);
			           else gcur(MLX2,MLY2);
		              sendfill(meny[1].nummer);
			      goto exit2;
			  }
 	         if(clarbf[2]==TRUE){
				  /* Anv{nd meny[2] */
				  clarbf[2]=FALSE;
				  lasmeny(2,cmpbuf);
				  intoinne(2,cmpbuf);
				  if(pl==0) gcur(MPX3,MPY3);
				       else gcur(MLX3,MLY3);
				  sendfill(meny[2].nummer);
		 }

             }
exit2:;
              send();
		   
	      switch ( c ){
		  case '\033':
		  cnt=0;    /*clear keybuf    */
		  break;
	      }

  	    break;  /* end of case 1-4 */

	   case '\033':
	        cnt=0;    /*clear keybuf    */
		break;

	    } /* end of switch ( d ) */

	}/* end of for ****(MAIN-loop)***** */
exit1:;
        Rmicons(0);                             /* remove icons         */
        setcooked();                            /* remove raw mode      */
        sendfill("\033[0v");                    /* cursor on            */
        cls();                                  /* clear screen         */
        send();                                 /* flush buffer         */
}       /* main */
/**************************************************************************/

pscupp(mn)
int mn;
{
    /*SCROLL UPP*/
    if(clarbf[mn]==FALSE){
	if(scr[mn]<=18){
	    for(i=(mn*12);i<((mn*12)+6);i++){
		rectmove(i+6,i,0);
		rectmove(SVARTRUT,i+6,0);
	    }
	    scr[mn] = scr[mn]+6;
	    for(i=6;i<12;i++){
		if(meny[mn].falt[i+scr[mn]].iconf[0]!='0'){
		    Rgraphics(meny[mn].falt[i+scr[mn]].iconf,i+(mn*12));
		}
	    }
	}
    }
    send();
    return;
}

pscner(mn)
int mn;
{
    /*SCROLL NER*/
    if(clarbf[mn]==FALSE){
	if(scr[mn]>=6){
	    for(i=(mn*12);i<((mn*12)+6);i++){
		rectmove(i,i+6,0);
		rectmove(SVARTRUT,i,0);
	    }
	    scr[mn] = scr[mn]-6;
	    for(i=0;i<6;i++){
		if(meny[mn].falt[i+scr[mn]].iconf[0]!='0'){
		    Rgraphics(meny[mn].falt[i+scr[mn]].iconf,i+(mn*12));
		}
	    }
	}
    }
    send();
    return;
}

lscupp(mn)
int mn;
{
    /*SCROLL UPP*/
    if(clarbf[mn]==FALSE){
	if(scr[mn]<24){
	    for(i=(mn*12);i<((mn*12)+12);i++){
		rectmove(SVARTRUT,i,0);
	    }
	    scr[mn] = scr[mn]+12;
	    for(i=0;i<12;i++){
		if(meny[mn].falt[i+scr[mn]].iconf[0]!='0'){
		    Rgraphics(meny[mn].falt[i+scr[mn]].iconf,i+(mn*12));
		}
	    }
	}
    }
    send();
    return;
}

lscner(mn)
int mn;
{
    /*SCROLL NER*/
    if(clarbf[mn]==FALSE){
	if(scr[mn]>=12){
	    for(i=(mn*12);i<((mn*12)+12);i++){
		rectmove(SVARTRUT,i,0);
	    }
	    scr[mn] = scr[mn]-12;
	    for(i=0;i<12;i++){
		if(meny[mn].falt[i+scr[mn]].iconf[0]!='0'){
		    Rgraphics(meny[mn].falt[i+scr[mn]].iconf,i+(mn*12));
		}
	    }
	}
    }
    send();
    return;
}
/***************************************************************************/
save(mn)
int mn;
{
    int chk;
    if(clarbf[mn]==FALSE){
	chk=lagrameny(mn);
	if(chk>1){
	    clrinne(mn);
	    scr[mn]=0;
	    clarbf[mn]=TRUE;

	    if(mn==0){
		if(pl==0){
		    gcur(MPX1,MPY1);
		    fill(MPX1+(14*9)-1,MPY1+13,0);
		}
		else{
		    gcur(MLX1,MLY1);
		    fill(MLX1+(14*9)-1,MLY1+13,0);
		}
	    }

	    if(mn==1){
		if(pl==0){
		    gcur(MPX2,MPY2);
		    fill(MPX2+(14*9)-1,MPY2+13,0);
		}
		else{
		    gcur(MLX2,MLY2);
		    fill(MLX2+(14*9)-1,MLY2+13,0);
		}
	    }

	    if(mn==2){
		if(pl==0){
		    gcur(MPX3,MPY3);
		    fill(MPX3+(14*9)-1,MPY3+13,0);
		}
		else{
		    gcur(MLX3,MLY3);
		    fill(MLX3+(14*9)-1,MLY3+13,0);
		}
	    }

	}
    }
    return;
}
/************************************************************************/
extcheck(buf)
char buf[NAMESIZE];
{
    int i,j,d;
    char ext[4];

    i=0;
    ext[3]='\000';
    while((buf[i]!='.')&&(i<NAMESIZE))i++;
    if(buf[i]=='.'){
	for(j=0;j<3;j++)ext[j]=buf[j+i+1];
	d=strcmp(ext,"nod");
        if(d==0)return(1);
    }
    return(0);
}
/************************************************************************/
undercheck(i,buf,glugg)
int i,glugg;
char buf[NAMESIZE+1];
{
    int  a,d,j,k,ff;
    char installname[BUFSIZE];
    char *inbp,*inep,plch;
    char chkref[NAMESIZE+1];
    char chka[NAMESIZE+1];
    char chkb[NAMESIZE+1];

    chkref[i]='\000';
    chka[i]='\000';
    chkb[i]='\000';
    
    for(a=0;a<i;a++)chkref[a]=buf[a];
    
    switch (glugg){
	case 0:
	    if(clarbf[1]==FALSE){
		for(a=0;a<i;a++){
		    chka[a]=mitt->nod[a];
		}
	    }
	    if(clarbf[2]==FALSE){
		for(a=0;a<i;a++){
		    chkb[a]=botten->nod[a];
		}
	    }
        break;
	case 1:
	    if(clarbf[0]==FALSE){
		for(a=0;a<i;a++){
		    chka[a]=topp->nod[a];
		}
	    }
	    if(clarbf[2]==FALSE){
		for(a=0;a<i;a++){
		    chkb[a]=botten->nod[a];
		}
	    }
        break;
	case 2:
	    if(clarbf[0]==FALSE){
		for(a=0;a<i;a++){
		    chka[a]=topp->nod[a];
		}
	    }
	    if(clarbf[1]==FALSE){
		for(a=0;a<i;a++){
		    chkb[a]=mitt->nod[a];
		}
	    }
        break;
    }

    if((d=strcmp(chkref,chka))==0)return(1);
    if((d=strcmp(chkref,chkb))==0)return(1);
    
    for(j=i;j<NAMESIZE;j++)buf[j]='0';
    buf[NAMESIZE]='\000';

    strcpy(installname,"./installed/");
    inbp=installname+strlen(installname);

    for(k=0;k<36;k++){      /* G} igenom alla f{lt  */
        if((k>=0)&&(k<=8)) plch=(k+'1');
	              else plch=(k-9+'a');
	buf[i]=plch;
	strcpy(inbp,buf);

	ff=open(installname,0);
	if(ff>0){
	    /* Granskad ikon {r far till undermeny */
	    close(ff);
	    return(1);
	}
    }
    return(0);
}
 
/************************************************************************/
/* end of memain.c */
/************************************************************************/
