/************************************************************************/
/*      mesub.c Funktioner till memain.c                                */
/*                                                                      */
/*      1985-10-08 Stig Bystr|m                                         */
/************************************************************************/
#include <win/w_const.h>
#include <win/w_types.h>
#include <win/w_structs.h>
#include <win/w_macros.h>
#undef FIOCLEX
#undef FIONCLEX
#include <errno.h>
#include <sgtty.h>
#include "medef.h"

extern int pl; /* portr{tt/landskaps flagga      */
extern int x,y;
extern char inbuf[256];
struct sgttyb ttysave;
extern char speed[];
extern int sptr;
extern int cnt;        /* # of characters left in keybuf[]*/
extern struct rectdes prekt[ANTEDFALT+ANTNYICON];/*win/w_structs.h */
extern struct rectdes lrekt[ANTEDFALT+ANTNYICON];

/************************************************************************/
setraw()        /* set raw mode                                */
{

        ioctl(0,TIOCGETP,&ttysave);
        ttysave.sg_flags |= RAW;
        ttysave.sg_flags &= ~ECHO;
        ioctl(0,TIOCSETP,&ttysave);
}

/************************************************************************/
setcooked()        /* set terminal cooked mode                  */
{

        ttysave.sg_flags &= ~RAW;
        ttysave.sg_flags |= ECHO;
        ioctl(0,TIOCSETP,&ttysave);
}


/************************************************************************/
getone()        /* get one character */
{
        static char     keybuf[256];     /* tty read buffer      */
        static char     *inbufp;        /* pointer to keybuf[]   */

        if( sptr>0 ) send();            /* flush buffer         */
        if( cnt == 0 ) {

	    /* software interrupt can occur */
	    while( cnt <= 0 ) {
		cnt = read(STDIN,&keybuf[0],256);
	    }

            inbufp = &keybuf[0];
        }
        if( cnt <= 0 ) return( 10 );     /* interrupt,return a 'lf' */
        cnt--;

        return(*inbufp++ & 255);
}


/************************************************************************/
point(x,y,op,colnr)
int x,y,op,colnr;
{
        if( op == 1 ) op = 0;
        else op = 1;
        sendfill("\033:");
        numout(x);
        sendfill(";");
        numout(y);
        sendfill(";");
        numout(op);
        sendfill(";");
        numout(colnr);
        sendfill("p");
}
/************************************************************************/
fill(x,y,op)
int x,y,op;
{
        sendfill("\033:");
        numout(x);
        sendfill(";");
        numout(y);
        sendfill(";;");
        numout(op);
        sendfill("f");
}

/************************************************************************/
fillpattn(x,y,pattn,op)
int x,y,pattn,op;
{
        sendfill("\033:");
        numout(x);
        sendfill(";");
        numout(y);
        sendfill(";");
        numout(pattn);
        sendfill(";");
        numout(op);
        sendfill("f");
}

/************************************************************************/
draw(x,y,pattrn,colnr)
int x,y,pattrn,colnr;
{
        sendfill("\033:");
        numout(x);
        sendfill(";");
        numout(y);
        sendfill(";");
        numout(pattrn);
        sendfill(";");
        numout(colnr);
        sendfill("d");
} 

/************************************************************************/
bline(x1,y1,x2,y2, colnr)        /* draw line from x1,y1 to x2,y2        */
int x1,y1,x2,y2, colnr;
{
        point(x1,y1,0,0);
        draw(x2,y2,0,colnr);
}       /* bline */



/************************************************************************/
rectang(x1,y1,x2,y2)            /* draw a rectanle with its corners in  */
register int x1,y1,x2,y2;       /* x1,y1 and x2,y2                      */
{
        bline(x1,y1,x2,y1,1);
        bline(x2,y1,x2,y2,1);
        bline(x2,y2,x1,y2,1);
        bline(x1,y2,x1,y1,1);
}       /* rectang */

/************************************************************************/
gcur(x,y)
int x,y;
{
    point(x,y,0);
    sendfill("\033:1H");
}
/************************************************************************/
cls()
{
        sendfill("\033[;H\033[2J");         /* Clear Screen (VT100      */
}

/************************************************************************/
setorigin(nr)
int nr;
{
    int x,y;

    if(pl==0){
	x=prekt[nr].r_xorig;
	y=prekt[nr].r_yorig;
    }
    else{
	x=lrekt[nr].r_xorig;
	y=lrekt[nr].r_yorig;
    }
    gcur(x,y);
    sendfill("\033:");
    numout(x);
    sendfill(";");
    numout(y);
    sendfill("O");
    send();
}
/************************************************************************/
fillfalt(nr)
int nr;
{
    int x,y;

    if(nr==RUTDUMMY){
	if(pl==0){
	    x=GLUGGPX;
	    y=GLUGGPY;
	}
	else{
	    x=GLUGGLX;
	    y=GLUGGLY;
	}
    }
    else{
	if(pl==0){
	    x=prekt[nr].r_xorig;
	    y=prekt[nr].r_yorig;
	}
	else{
	    x=lrekt[nr].r_xorig;
	    y=lrekt[nr].r_yorig;
	}
    }
    gcur(x,y);
    sendfill("\033:");
    numout(x+WIDTH-1);
    sendfill(";");
    numout(y+HEIGHT-1);
    sendfill(";;");
    numout(0);  /* Svart */
    sendfill("f");
    send();
}    
/*******************************/
fillgrayfalt(nr)
int nr;
{
    int x,y;

    if(pl==0){
	x=prekt[nr].r_xorig;
	y=prekt[nr].r_yorig;
    }
    else{
	x=lrekt[nr].r_xorig;
	y=lrekt[nr].r_yorig;
    }
    point(x,y,0,0);
    fillpattn(x+WIDTH-1,y+HEIGHT-1,1,0);
    send();
}    

/************************************************************************/
sendfill(str)   /* fill speed-buffer with characters from str */
char str[];
{
        register i;
        i=0;
        while( str[i] != '\000' )       {
                speed[sptr] = str[i];
                sptr++;
                i++;
                if( sptr>2047 ) send();
        }
}
/****************************************************************************/
send()          /* flush buffer to screen */
{
        write(STDOUT,&speed[0],sptr);
        sptr = 0;
}

/************************************************************************/
 
numout(n)
register n;
{
        char cnvbuf[20];        /* conversion buffer    */
        register char *s;       /* pointer to cnvbuf[]  */

        s = &cnvbuf[20-1];
        *s = '\0';
        do {
                *--s = n % 10 + '0';
        } while ((n /= 10) > 0);
        sendfill(s);

        return;
}       /* end of numout        */

/****************************************************************************/
