
/****************************************************************************/
/*                                                                          */
/*      mkwin.c                                                             */
/*                                                                          */
/*      Rutiner f|r mkicon.c                                                */
/*                                                                          */
/*      1985-11-01 Stig Bystr|m                                             */
/*                                                                          */
/****************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <win/w_const.h>
#include <win/w_types.h>
#include <win/w_structs.h>
#include <win/w_macros.h>
#undef FIOCLEX
#undef FIONCLEX
#include <sgtty.h>
#include <signal.h>
#include <errno.h>
#include "mkdef.h"

struct sgttyb ttysave;
extern char speed[4096];
extern int fw;                /* F|nster deskriptor */
extern int fwflg;             /* s{tts till TRUE n{r nytt f|nster anv{nds */
extern int sptr;
extern int echoflag;
extern int cnt;               /* # of characters left in keybuf[]*/

   /* Flaggor f|r ikoner (funktion mm) */

#define F0 I_PMODE+I_LMODE+I_INVERT+I_PRESS+I_RQST+I_LZERO
#define F1 I_PMODE+I_LMODE+I_PRESS+I_RQST+I_LZERO

   /* Icon-positioner och -storlek */

/*1  2   3   4   5   6   7   8   9   10  11  12  13  14*/

short xorig[] = {
 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 17,151,285,419};
short yorig[] = {
532,480,428,376,324,272,220,168,116, 64, 12,693,693,693,693};

short xsize[] = {
126,126,126,126,126,126,126,126,126,126,126,126,126,126,126};

short ysize[] = {
 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 40, 40, 40, 40};

  /* Kommando sekvens */
char *cmdseq[] = {
"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O"};

  /* Flaggsekvens (till ikonerna) */
short flags[] = {
 F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0};


/* F|nster f|r inmatning av parametrar till "window"   */
/*1  2   3   4   5   6   7   8   9   10  11  12  13  14*/

short fwxorig[] = {
 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
387,387,387,387,387,387,387,387,387,387,387,387, 17,284};

short fwyorig[] = {
584,532,480,428,376,324,272,220,168,116, 64, 12,
584,532,480,428,376,324,272,220,168,116, 64, 12,720,720};

short fwxsize[] = {
 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54,
 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54,126,126};

short fwysize[] = {
 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41,
 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 40, 40};

  /* Kommando sekvens */
char *fwcmdseq[] = {
"A","B","C","D","E","F","G","H","I","J","K","L",
"M","N","O","P","R","S","T","U","V","W","X","Y","Z","Q"};

  /* Flaggsekvens (till ikonerna) */
short fwflags[] = {
 F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0,
 F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0, F0};

struct winicon iconbp;       /* win/w_structs.h  */
struct winicon bp;       /* win/w_structs.h  */

int rsignal;

/******************************************************************/
/*   Iconpositioner l{ggs upp                                     */

winini()
{
        int i,j,c;
	char *ptr;

        for( i = 0; i < 15; i++ ) {
                bp.ip_xorig = xorig[i];
                bp.il_xorig = xorig[i];
                bp.ip_yorig = yorig[i];
                bp.il_yorig = yorig[i];
                bp.ip_xsize = xsize[i];
                bp.il_xsize = xsize[i];
                bp.ip_ysize = ysize[i];
                bp.il_ysize = ysize[i];
		ptr = cmdseq[i];
		j=0;
		while(bp.i_cmdseq[j++] = *ptr++);
                bp.i_flags = flags[i];
		if( (c=Winicon(1, &bp)) < 0){
		    return(1);
		}
		if( bp.i_rstat != W_OK ){
		    return(1);
		}
	}

        wrmenu();                       /* Rita upp grafiken i f|nstret */
        return(0);
}

/****************************************************************************/
/*  Grafiken i f|nstret                                                     */

wrmenu()
{
    char c;
    char tmpbuf[256];
    char *tmpbufp;
    int i,a,b,x,y;
    
    cls();
    rectang(0,0,767,767);
    rectang(2,2,765,765);
    for(i=0;i<11;i++){
	a=(52*i)+9;
	b=(52*i)+55;
	x=xorig[i];
	y=yorig[i];
        rectang(9,a,758,b);
	rectang(x-1,y-1,x+126,y+41);
    }
    rectang(9,582,758,737);
    rectang(11,584,756,682);
    for(i=11;i<15;i++){
	x=xorig[i];
	y=yorig[i];
	rectang(x-1,y-1,x+126,y+40);
    }
    gcur(xorig[0]+36,yorig[0]+12);
    sendfill("window");
    gcur(xorig[0]+131,yorig[0]+26);
    sendfill("Data f|r f|nstret som ska anv{ndas som terminal");
    gcur(xorig[0]+131,yorig[0]+13);
    sendfill("Storlek,placering,bakgrund mm ");
    gcur(xorig[0]+131,yorig[0]);
    sendfill("M}ste anges om inte ikonen {r av typen .nod");
    gcur(xorig[1]+36,yorig[1]+12);
    sendfill("header");    
    gcur(xorig[1]+131,yorig[1]+26);
    sendfill("Rubriken p} f|nstret (\\verst)");
    gcur(xorig[1]+131,yorig[1]+13);
    sendfill(" ");
    gcur(xorig[1]+131,yorig[1]);
    sendfill(" ");
    gcur(xorig[2]+27,yorig[2]+12);
    sendfill("zoomlist");    
    gcur(xorig[2]+131,yorig[2]+26);
    sendfill("Ska man kunna {ndra font-storleken i f|nstret ? ");
    gcur(xorig[2]+131,yorig[2]+13);
    sendfill(" ");
    gcur(xorig[2]+131,yorig[2]);
    sendfill(" ");
    gcur(xorig[3]+31,yorig[3]+12);
    sendfill("pointer");    
    gcur(xorig[3]+131,yorig[3]+26);
    sendfill(" ");
    gcur(xorig[3]+131,yorig[3]+13);
    sendfill("EJ Implementerat");
    gcur(xorig[3]+131,yorig[3]);
    sendfill(" ");    
    gcur(xorig[4]+45,yorig[4]+12);
    sendfill("icon");    
    gcur(xorig[4]+131,yorig[4]+26);
    sendfill(" ");
    gcur(xorig[4]+131,yorig[4]+13);
    sendfill("EJ Implementerat");
    gcur(xorig[4]+131,yorig[4]);
    sendfill(" ");
    gcur(xorig[5]+36,yorig[5]+12);
    sendfill("string");
    gcur(xorig[5]+131,yorig[5]+26);
    sendfill(" ");
    gcur(xorig[5]+131,yorig[5]+13);
    sendfill("Ej Implementerat");
    gcur(xorig[5]+131,yorig[5]);
    sendfill(" ");
    gcur(xorig[6]+13,yorig[6]+12);
    sendfill("directory");    
    gcur(xorig[6]+131,yorig[6]+26);
    sendfill("F|rflyttning till annat directory innan start av programmet");
    gcur(xorig[6]+131,yorig[6]+13);
    sendfill("Om ej n}got directory specifieras anv{nds det");
    gcur(xorig[6]+131,yorig[6]);
    sendfill("som wsh startas fr}n");
    gcur(xorig[7]+40,yorig[7]+12);
    sendfill("super");    
    gcur(xorig[7]+131,yorig[7]+26);
    sendfill(" ");
    gcur(xorig[7]+131,yorig[7]+13);
    sendfill("EJ Implementerat");
    gcur(xorig[7]+131,yorig[7]);
    sendfill(" ");
    gcur(xorig[8]+45,yorig[8]+12);
    sendfill("wait");    
    gcur(xorig[8]+131,yorig[8]+26);
    sendfill("S{tter wsh att v{nta p} att command avslutats.");
    gcur(xorig[8]+131,yorig[8]+13);
    sendfill(" ");
    gcur(xorig[8]+131,yorig[8]);
    sendfill(" ");
    gcur(xorig[9]+31,yorig[9]+12);
    sendfill("environ");    
    gcur(xorig[9]+131,yorig[9]+26);
    sendfill("Anger vilken milj| som f|nstret ska arbeta i. tex vt100 mm");
    gcur(xorig[9]+131,yorig[9]+13);
    sendfill(" ");
    gcur(xorig[9]+131,yorig[9]);
    sendfill(" ");
    gcur(xorig[10]+31,yorig[10]+12);
    sendfill("command");
    gcur(xorig[10]+131,yorig[10]+26);
    sendfill("Specifikation av vilket program som ska startas i f|nstret.");
    gcur(xorig[10]+131,yorig[10]+13);
    sendfill("M}ste anges om inte ikonen {r av typen .nod");
    gcur(xorig[10]+131,yorig[10]);
    sendfill(" ");
    gcur(xorig[11]+45,yorig[11]+12);
    sendfill("KLAR");
    gcur(xorig[12]+31,yorig[12]+12);
    sendfill("OMSTART");
    gcur(xorig[13]+36,yorig[13]+12);
    sendfill("AVBRYT");
    gcur(xorig[14]+9,yorig[14]+12);
    sendfill("VAD [R GJORT");
    gcur(314,750);
    sendfill("TERMINAL EDITOR");
    gcur(12,585);
    fill(755,681,0);
    gcur(17,665);
    sendfill("Anv{nd ikonerna f|r att skapa kommandon !!");
    gcur(17,650);
    sendfill("Avsluta med ikonen KLAR.");

    send();
}
/************************************************************************/
/* F|nster f|r inmatning av parametrar till "window" ovan  */
fwwinini()
{
    int i,j,d,x,y;
    char *ptr;

    for(i=0;i<26;i++){
	iconbp.ip_xorig = fwxorig[i];
	iconbp.il_xorig = fwxorig[i];
	iconbp.ip_yorig = fwyorig[i];
	iconbp.il_yorig = fwyorig[i];
	iconbp.ip_xsize = fwxsize[i];
	iconbp.il_xsize = fwxsize[i];
	iconbp.ip_ysize = fwysize[i];
	iconbp.il_ysize = fwysize[i];
	ptr=fwcmdseq[i];
	j=0;
	while(iconbp.i_cmdseq[j++] = *ptr++);
	iconbp.i_flags = fwflags[i];
	if( (d=Winicon(fw, &iconbp)) < 0){
	    return(1);
	}
	if( iconbp.i_rstat != W_OK ){
	    return(1);
	}
    }
    /* grafik */
    rectang(0,0,767,767);
    rectang(2,2,765,765);
    for(i=0;i<24;i++){
	x=fwxorig[i];
	y=fwyorig[i];
	rectang(x-3,y-3,x+368,y+43);
	rectang(x-1,y-1,x+54,y+41);
    }
    rectang(9,717,418,762);
    for(i=24;i<26;i++){
	x=fwxorig[i];
	y=fwyorig[i];
	rectang(x-1,y-1,x+126,y+40);
    }
    sendfw();

    gcur(fwxorig[0]+9,fwyorig[0]+12);
    sendfill("hscr");
    gcur(fwxorig[0]+70,fwyorig[0]+26);
    sendfill(" ");
    gcur(fwxorig[0]+70,fwyorig[0]+13);
    sendfill(" ");
    gcur(fwxorig[0]+70,fwyorig[0]);
    sendfill(" ");
    gcur(fwxorig[1]+9,fwyorig[1]+12);
    sendfill("vscr");
    gcur(fwxorig[1]+70,fwyorig[1]+26);
    sendfill(" ");
    gcur(fwxorig[1]+70,fwyorig[1]+13);
    sendfill(" ");
    gcur(fwxorig[1]+70,fwyorig[1]);
    sendfill(" ");
    gcur(fwxorig[2]+9,fwyorig[2]+12);
    sendfill("cbox");
    gcur(fwxorig[2]+70,fwyorig[2]+26);
    sendfill(" ");
    gcur(fwxorig[2]+70,fwyorig[2]+13);
    sendfill(" ");
    gcur(fwxorig[2]+70,fwyorig[2]);
    sendfill(" ");
    gcur(fwxorig[3]+9,fwyorig[3]+12);
    sendfill("sbox");
    gcur(fwxorig[3]+70,fwyorig[3]+26);
    sendfill(" ");
    gcur(fwxorig[3]+70,fwyorig[3]+13);
    sendfill(" ");
    gcur(fwxorig[3]+70,fwyorig[3]);
    sendfill(" ");
    gcur(fwxorig[4]+9,fwyorig[4]+12);
    sendfill("mbox");
    gcur(fwxorig[4]+70,fwyorig[4]+26);
    sendfill(" ");
    gcur(fwxorig[4]+70,fwyorig[4]+13);
    sendfill(" ");
    gcur(fwxorig[4]+70,fwyorig[4]);
    sendfill(" ");
    gcur(fwxorig[5]+9,fwyorig[5]+12);
    sendfill("zbox");
    gcur(fwxorig[5]+70,fwyorig[5]+26);
    sendfill(" ");
    gcur(fwxorig[5]+70,fwyorig[5]+13);
    sendfill(" ");
    gcur(fwxorig[5]+70,fwyorig[5]);
    sendfill(" ");
    gcur(fwxorig[6]+9,fwyorig[6]+12);
    sendfill("pmod");
    gcur(fwxorig[6]+70,fwyorig[6]+26);
    sendfill(" ");
    gcur(fwxorig[6]+70,fwyorig[6]+13);
    sendfill(" ");
    gcur(fwxorig[6]+70,fwyorig[6]);
    sendfill(" ");
    gcur(fwxorig[7]+9,fwyorig[7]+12);
    sendfill("lmod");
    gcur(fwxorig[7]+70,fwyorig[7]+26);
    sendfill(" ");
    gcur(fwxorig[7]+70,fwyorig[7]+13);
    sendfill(" ");
    gcur(fwxorig[7]+70,fwyorig[7]);
    sendfill(" ");
    gcur(fwxorig[8]+9,fwyorig[8]+12);
    sendfill("stxt");
    gcur(fwxorig[8]+70,fwyorig[8]+26);
    sendfill(" ");
    gcur(fwxorig[8]+70,fwyorig[8]+13);
    sendfill(" ");
    gcur(fwxorig[8]+70,fwyorig[8]);
    sendfill(" ");
    gcur(fwxorig[9]+9,fwyorig[9]+12);
    sendfill("sbmp");
    gcur(fwxorig[9]+70,fwyorig[9]+26);
    sendfill(" ");
    gcur(fwxorig[9]+70,fwyorig[9]+13);
    sendfill(" ");
    gcur(fwxorig[9]+70,fwyorig[9]);
    sendfill(" ");
    gcur(fwxorig[10]+9,fwyorig[10]+12);
    sendfill("lock");
    gcur(fwxorig[10]+70,fwyorig[10]+26);
    sendfill(" ");
    gcur(fwxorig[10]+70,fwyorig[10]+13);
    sendfill(" ");
    gcur(fwxorig[10]+70,fwyorig[10]);
    sendfill(" ");
    gcur(fwxorig[11]+9,fwyorig[11]+12);
    sendfill("novr");
    gcur(fwxorig[11]+70,fwyorig[11]+26);
    sendfill(" ");
    gcur(fwxorig[11]+70,fwyorig[11]+13);
    sendfill(" ");
    gcur(fwxorig[11]+70,fwyorig[11]);
    sendfill(" ");
    gcur(fwxorig[12]+9,fwyorig[12]+12);
    sendfill("ncur");
    gcur(fwxorig[12]+70,fwyorig[12]+26);
    sendfill(" ");
    gcur(fwxorig[12]+70,fwyorig[12]+13);
    sendfill(" ");
    gcur(fwxorig[12]+70,fwyorig[12]);
    sendfill(" ");
    gcur(fwxorig[13]+9,fwyorig[13]+12);
    sendfill("nmov");
    gcur(fwxorig[13]+70,fwyorig[13]+26);
    sendfill(" ");
    gcur(fwxorig[13]+70,fwyorig[13]+13);
    sendfill(" ");
    gcur(fwxorig[13]+70,fwyorig[13]);
    sendfill(" ");
    gcur(fwxorig[14]+9,fwyorig[14]+12);
    sendfill("alls");
    gcur(fwxorig[14]+70,fwyorig[14]+26);
    sendfill(" ");
    gcur(fwxorig[14]+70,fwyorig[14]+13);
    sendfill(" ");
    gcur(fwxorig[14]+70,fwyorig[14]);
    sendfill(" ");
    gcur(fwxorig[15]+9,fwyorig[15]+12);
    sendfill("spec");
    gcur(fwxorig[15]+70,fwyorig[15]+26);
    sendfill(" ");
    gcur(fwxorig[15]+70,fwyorig[15]+13);
    sendfill(" ");
    gcur(fwxorig[15]+70,fwyorig[15]);
    sendfill(" ");
    gcur(fwxorig[16]+9,fwyorig[16]+12);
    sendfill("kscr");
    gcur(fwxorig[16]+70,fwyorig[16]+26);
    sendfill(" ");
    gcur(fwxorig[16]+70,fwyorig[16]+13);
    sendfill(" ");
    gcur(fwxorig[16]+70,fwyorig[16]);
    sendfill(" ");
    gcur(fwxorig[17]+9,fwyorig[17]+12);
    sendfill("wscr");
    gcur(fwxorig[17]+70,fwyorig[17]+26);
    sendfill(" ");
    gcur(fwxorig[17]+70,fwyorig[17]+13);
    sendfill(" ");
    gcur(fwxorig[17]+70,fwyorig[17]);
    sendfill(" ");
    gcur(fwxorig[18]+9,fwyorig[18]+12);
    sendfill("amsp");
    gcur(fwxorig[18]+70,fwyorig[18]+26);
    sendfill(" ");
    gcur(fwxorig[18]+70,fwyorig[18]+13);
    sendfill(" ");
    gcur(fwxorig[18]+70,fwyorig[18]);
    sendfill(" ");
    gcur(fwxorig[19]+9,fwyorig[19]+12);
    sendfill("rtlv");
    gcur(fwxorig[19]+70,fwyorig[19]+26);
    sendfill(" ");
    gcur(fwxorig[19]+70,fwyorig[19]+13);
    sendfill(" ");
    gcur(fwxorig[19]+70,fwyorig[19]);
    sendfill(" ");
    gcur(fwxorig[20]+9,fwyorig[20]+12);
    sendfill("ncpi");
    gcur(fwxorig[20]+70,fwyorig[20]+26);
    sendfill(" ");
    gcur(fwxorig[20]+70,fwyorig[20]+13);
    sendfill(" ");
    gcur(fwxorig[20]+70,fwyorig[20]);
    sendfill(" ");
    gcur(fwxorig[21]+9,fwyorig[21]+12);
    sendfill("ncpo");
    gcur(fwxorig[21]+70,fwyorig[21]+26);
    sendfill(" ");
    gcur(fwxorig[21]+70,fwyorig[21]+13);
    sendfill(" ");
    gcur(fwxorig[21]+70,fwyorig[21]);
    sendfill(" ");
    gcur(fwxorig[22]+9,fwyorig[22]+12);
    sendfill("text");
    gcur(fwxorig[22]+70,fwyorig[22]+26);
    sendfill(" ");
    gcur(fwxorig[22]+70,fwyorig[22]+13);
    sendfill(" ");
    gcur(fwxorig[22]+70,fwyorig[22]);
    sendfill(" ");
    gcur(fwxorig[23]+9,fwyorig[23]+12);
    sendfill("wgrp");
    gcur(fwxorig[23]+70,fwyorig[23]+26);
    sendfill(" ");
    gcur(fwxorig[23]+70,fwyorig[23]+13);
    sendfill(" ");
    gcur(fwxorig[23]+70,fwyorig[23]);
    sendfill(" ");
    gcur(fwxorig[24]+45,fwyorig[24]+12);
    sendfill("KLAR");
    gcur(fwxorig[25]+36,fwyorig[25]+12);
    sendfill("AVBRYT");

    sendfw();
    return(0);
}
/************************************************************************/
rut(i,op) /* ruta i valda parametrar i fw */
int i,op;
{
    gcur(fwxorig[i],fwyorig[i]);
    fill(fwxorig[i]+12,fwyorig[i]+12,op);
    sendfw();
}
/************************************************************************/
setraw()        /* set raw mode                                */
{

        ioctl(0,TIOCGETP,&ttysave);
        ttysave.sg_flags |= RAW;
        ttysave.sg_flags &= ~ECHO;
        ioctl(0,TIOCSETP,&ttysave);
}

/************************************************************************/
setcooked()        /* set terminal cooked mode                  */
{

        ttysave.sg_flags &= ~RAW;
        ttysave.sg_flags |= ECHO;
        ioctl(0,TIOCSETP,&ttysave);
}

setfwraw()        /* set fw raw mode                                */
{

        ioctl(fw,TIOCGETP,&ttysave);
        ttysave.sg_flags |= RAW;
        ttysave.sg_flags &= ~ECHO;
        ioctl(fw,TIOCSETP,&ttysave);
}

/************************************************************************/
setfwcooked()        /* set fw-terminal cooked mode                  */
{

        ttysave.sg_flags &= ~RAW;
        ttysave.sg_flags |= ECHO;
        ioctl(fw,TIOCSETP,&ttysave);
}


/************************************************************************/
getone()        /* get one character with echo                  */
{
        static char     keybuf[256];     /* tty read buffer      */
        static char     *inbufp;        /* pointer to keybuf[]   */

        if( echoflag == 1) sendfill("\033[?35l");    /* cursor on */
        if( sptr>0 ) send();            /* flush buffer         */
        if( cnt == 0 ) {


        /* software interrupt can occur */
        while( cnt <= 0 ) {                                       
              if((cnt = read(STDIN,&keybuf[0],256)) <= 0 ) {      
              }                                                   
        }                                                         

  
            inbufp = &keybuf[0];
        }
        if( cnt <= 0 ) return( 10 );     /* interrupt,return a 'lf' */
        cnt--;
        if( echoflag == 1) write(STDOUT,inbufp,1);         /* echo char   */
        return(*inbufp++ & 255);
}

/****************************************************************************/
getfw()        /* get one character with echo                  */
{
        static char     keybuf[256];     /* tty read buffer      */
        static char     *inbufp;        /* pointer to keybuf[]   */

        if( echoflag == 1) sendfill("\033[?35l");    /* cursor on */
        if( sptr>0 ) sendfw();            /* flush buffer         */
        if( cnt == 0 ) {


        /* software interrupt can occur */
        while( cnt <= 0 ) {                                       
              if((cnt = read(fw,&keybuf[0],256)) <= 0 ) {      
              }                                                   
        }                                                         

  
            inbufp = &keybuf[0];
        }
        if( cnt <= 0 ) return( 10 );     /* interrupt,return a 'lf' */
        cnt--;
/*        if( echoflag == 1) write(fw,inbufp,1);         /* echo char   */
        return(*inbufp++ & 255);
}


/************************************************************************/
point(x,y,op,colnr)
int x,y,op,colnr;
{
        if( op == 1 ) op = 0;
        else op = 1;
        sendfill("\033:");
        numout(x);
        sendfill(";");
        numout(y);
        sendfill(";");
        numout(op);
        sendfill(";");
        numout(colnr);
        sendfill("p");
}
/************************************************************************/
fill(x,y,op)
int x,y,op;
{
        sendfill("\033:");
        numout(x);
        sendfill(";");
        numout(y);
        sendfill(";;");
        numout(op);
        sendfill("f");
}

/************************************************************************/
fillpattn(x,y,pattn,op)
int x,y,pattn,op;
{
        sendfill("\033:");
        numout(x);
        sendfill(";");
        numout(y);
        sendfill(";");
        numout(pattn);
        sendfill(";");
        numout(op);
        sendfill("f");
}

/************************************************************************/
draw(x,y,pattrn,colnr)
int x,y,pattrn,colnr;
{
        sendfill("\033:");
        numout(x);
        sendfill(";");
        numout(y);
        sendfill(";");
        numout(pattrn);
        sendfill(";");
        numout(colnr);
        sendfill("d");
} 

/************************************************************************/
bline(x1,y1,x2,y2, colnr)        /* draw line from x1,y1 to x2,y2        */
int x1,y1,x2,y2, colnr;
{
        point(x1,y1,0,0);
        draw(x2,y2,0,colnr);
}       /* bline */



/************************************************************************/
rectang(x1,y1,x2,y2)            /* draw a rectanle with its corners in  */
register int x1,y1,x2,y2;       /* x1,y1 and x2,y2                      */
{
        bline(x1,y1,x2,y1,1);
        bline(x2,y1,x2,y2,1);
        bline(x2,y2,x1,y2,1);
        bline(x1,y2,x1,y1,1);
}       /* rectang */

/************************************************************************/
gcur(x,y)
int x,y;
{
    point(x,y,0);
    sendfill("\033:1H");
}
/************************************************************************/
cls()
{
        sendfill("\033[;H\033[2J");         /* Clear Screen (VT100)      */
}

/************************************************************************/
setorigin(nr)
int nr;
{
    int x,y;

    x=xorig[nr];
    y=yorig[nr];

    gcur(x,y);
    sendfill("\033:");
    numout(x);
    sendfill(";");
    numout(y);
    sendfill("O");
    send();
}

/************************************************************************/
sendfill(str)   /* fill speed-buffer with characters from str */
char str[];
{
        register i;
        i=0;
        while( str[i] != '\000' )       {
                speed[sptr] = str[i];
                sptr++;
                i++;
                if( sptr>2047 ){
		    if(fwflg==FALSE) send();
		                else sendfw();
		}		                
        }
}
/****************************************************************************/
send()          /* flush buffer to screen */
{
        write(STDOUT,&speed[0],sptr);
        sptr = 0;
}
/****************************************************************************/
sendfw()          /* flush buffer to fw */
{
        write(fw,&speed[0],sptr);
        sptr = 0;
}

/************************************************************************/
 
numout(n)
register n;
{
        char cnvbuf[20];        /* conversion buffer    */
        register char *s;       /* pointer to cnvbuf[]  */

        s = &cnvbuf[20-1];
        *s = '\0';
        do {
                *--s = n % 10 + '0';
        } while ((n /= 10) > 0);
        sendfill(s);

        return;
}       /* end of numout        */

/****************************************************************************/
 
windnumout(n,pek)
register n;
char *pek;
{
        char cnvbuf[20];        /* conversion buffer    */
        register char *s;       /* pointer to cnvbuf[]  */

        s = &cnvbuf[20-1];
        *s = '\0';
        do {
                *--s = n % 10 + '0';
        } while ((n /= 10) > 0);
        strcpy(pek,s);

        return;
}       /* end of numout        */

/****************************************************************************/

/**************************************************************************/
/* Initiering av rutiner f|r omritning av grafiken n{r f|nstret har       */
/* {ndrat sig p} n}got s{tt.                                              */
/* Returnerar 0 d} initieringen fungerar                                  */
/**************************************************************************/
int
w_reini()
{
        struct winstruc wd;
        struct winstruc *wdp;
        int             w_rstrp();

        wdp = &wd;
        if( Winstat(STDIN,wdp) < 0 || wdp->w_rstat != W_OK ) {
                sendfill("Winstat not OK\n\r");
                return(1);
        }
        if( (rsignal = wdp->w_rsig) == 0 ) {
                sendfill("rsignal not OK\n\r");
                return(1);
        }
        signal(rsignal,w_rstrp);
        return(0);
}

/****************************************************************************/
w_rstrp()       /* Det h{r {r avbrottssignalrutinen som ritar om */
{               /* f|nstret n{r det har {ndrat sig               */
        signal(rsignal,SIG_IGN);
        wrmenu();                 /*Ritar om grafiken */
        send();
        signal(rsignal,w_rstrp);
}
/****************************************************************************/

/****************************************************************************/
/* End of mkwin.c till mkicon.c        					    */
/****************************************************************************/
